%{
#include <string.h>
#include "parse.h"
#include "y.tab.h"
#include "ex1.h"

struct keyword  token[MAX_TOKEN] = {
 {"ABS"    , 3, FUNC , ABS      , vABS      , (f_t *) TRAITEMENT_vABS      , 0xDF49},
 {"AND"    , 3, OPER , AND      , vAND      , (f_t *) TRAITEMENT_vAND      , 1010},
 {"ASC"    , 3, FUNC , ASC      , vASC      , (f_t *) TRAITEMENT_vASC      , 1010},
 {"ATN"    , 3, FUNC , ATN      , vATN      , (f_t *) TRAITEMENT_vATN      , 0xE43F},
 {"AUTO"   , 4, NONE , AUTO     , vAUTO     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"CALL"   , 4, PROC , CALL     , vCALL     , (f_t *) TRAITEMENT_vCALL     , 1010},
 {"CHAR"   , 4, FUNC , CHAR     , vCHAR     , (f_t *) TRAITEMENT_vCHAR     , 1010},
 {"CHR$"   , 4, FUNC , CHR      , vCHR      , (f_t *) TRAITEMENT_vCHR      , 1010},
 {"CIRCLE" , 6, PROC , CIRCLE   , vCIRCLE   , (f_t *) TRAITEMENT_vCIRCLE   , 1010},
 {"CLEAR"  , 5, PROC , CLEAR    , vCLEAR    , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"CLOAD"  , 5, PROC , CLOAD    , vCLOAD    , (f_t *) TRAITEMENT_vCLOAD    , 1010},
 {"CLS"    , 3, PROC , CLS      , vCLS      , (f_t *) TRAITEMENT_vCLS      , 1010},
 {"CONT"   , 4, PROC , CONT     , vCONT     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"COS"    , 3, FUNC , COS      , vCOS      , (f_t *) TRAITEMENT_vCOS      , 0xE38B},
 {"CSAVE"  , 5, PROC , CSAVE    , vCSAVE    , (f_t *) TRAITEMENT_vCSAVE    , 1010},
 {"CURMOV" , 6, PROC , CURMOV   , vCURMOV   , (f_t *) TRAITEMENT_vCURMOV   , 1010},
 {"CURSET" , 6, PROC , CURSET   , vCURSET   , (f_t *) TRAITEMENT_vCURSET   , 1010},
 {"DATA"   , 4, FUNC , DATA     , vDATA     , (f_t *) TRAITEMENT_vDATA     , 1010},
 {"DEEK"   , 4, FUNC , DEEK     , vDEEK     , (f_t *) TRAITEMENT_vDEEK     , 1010},
 {"DEF"    , 3, PROC , DEF      , vDEF      , (f_t *) TRAITEMENT_vDEF      , 1010},
 {"DIM"    , 3, PROC , DIM      , vDIM      , (f_t *) TRAITEMENT_vDIM      , 1010},
 {"DOKE"   , 4, PROC , DOKE     , vDOKE     , (f_t *) TRAITEMENT_vDOKE     , 1010},
 {"DRAW"   , 4, PROC , DRAW     , vDRAW     , (f_t *) TRAITEMENT_vDRAW     , 1010},
 {"EDIT"   , 4, PROC , EDIT     , vEDIT     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"ELSE"   , 4, PROC , ELSE     , vELSE     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"END"    , 3, PROC , END      , vEND      , (f_t *) TRAITEMENT_vEND      , 1010},
 {"EXP"    , 3, FUNC , EXP      , vEXP      , (f_t *) TRAITEMENT_vEXP      , 0xE2AA},
 {"EXPLODE", 7, NONE , EXPLODE  , vEXPLODE  , (f_t *) TRAITEMENT_vEXPLODE  , 0xFACB},
 {"FALSE"  , 5, VALUE, FALSE    , vFALSE    , (f_t *) TRAITEMENT_vFALSE    , 1010},
 {"FILL"   , 4, PROC , FILL     , vFILL     , (f_t *) TRAITEMENT_vFILL     , 1010},
 {"FN"     , 2, PROC , FN       , vFN       , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"FOR"    , 3, PROC , FOR      , vFOR      , (f_t *) TRAITEMENT_vFOR      , 1010},
 {"FRE"    , 3, FUNC , FRE      , vFRE      , (f_t *) TRAITEMENT_vFRE      , 1010},
 {"GET"    , 3, FUNC , GET      , vGET      , (f_t *) TRAITEMENT_vGET      , 1010},
 {"GOSUB"  , 5, PROC , GOSUB    , vGOSUB    , (f_t *) TRAITEMENT_vGOSUB    , 1010},
 {"GOTO"   , 4, PROC , GOTO     , vGOTO     , (f_t *) TRAITEMENT_vGOTO     , 1010},
 {"GRAB"   , 4, PROC , GRAB     , vGRAB     , (f_t *) TRAITEMENT_vGRAB     , 1010},
 {"HEX$"   , 4, FUNC , HEX      , vHEX      , (f_t *) TRAITEMENT_vHEX      , 1010},
 {"HIMEM"  , 5, PROC , HIMEM    , vHIMEM    , (f_t *) TRAITEMENT_vHIMEM    , 1010},
 {"HIRES"  , 5, PROC , HIRES    , vHIRES    , (f_t *) TRAITEMENT_vHIRES    , 0xEC33},
 {"IF"     , 2, PROC , IF       , vIF       , (f_t *) TRAITEMENT_vIF       , 1010},
 {"INK"    , 3, PROC , INK      , vINK      , (f_t *) TRAITEMENT_vINK      , 1010},
 {"INPUT"  , 5, FUNC , INPUT    , vINPUT    , (f_t *) TRAITEMENT_vINPUT    , 1010},
 {"INT"    , 3, FUNC , INT      , vINT      , (f_t *) TRAITEMENT_vINT      , 1010},
 {"KEY$"   , 4, FUNC , KEY      , vKEY      , (f_t *) TRAITEMENT_vKEY      , 1010},
 {"LEFT$"  , 5, FUNC , LEFT     , vLEFT     , (f_t *) TRAITEMENT_vLEFT     , 1010},
 {"LEN"    , 3, FUNC , LEN      , vLEN      , (f_t *) TRAITEMENT_vLEN      , 1010},
 {"LET"    , 3, PROC , LET      , vLET      , (f_t *) TRAITEMENT_vLET      , 1010},
 {"LIST"   , 4, FUNC , LIST     , vLIST     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"LLIST"  , 5, FUNC , LLIST    , vLLIST    , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"LN"     , 2, FUNC , LN       , vLN       , (f_t *) TRAITEMENT_vLN       , 0xDCAF},
 {"LOG"    , 3, FUNC , LOG      , vLOG      , (f_t *) TRAITEMENT_vLOG      , 0xDDD4},
 {"LORES"  , 5, PROC , LORES    , vLORES    , (f_t *) TRAITEMENT_vLORES    , 0xD9DE},
 {"LPRINT" , 6, FUNC , LPRINT   , vLPRINT   , (f_t *) TRAITEMENT_vLPRINT   , 1010},
 {"MID$"   , 4, FUNC , MID      , vMID      , (f_t *) TRAITEMENT_vMID      , 1010},
 {"MUSIC"  , 5, PROC , MUSIC    , vMUSIC    , (f_t *) TRAITEMENT_vMUSIC    , 1010},
 {"NEW"    , 3, PROC , NEW      , vNEW      , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"NEXT"   , 4, PROC , NEXT     , vNEXT     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"NOT"    , 3, OPER , NOT      , vNOT      , (f_t *) TRAITEMENT_vNOT      , 1010},
 {"ON"     , 2, FUNC , ON       , vON       , (f_t *) TRAITEMENT_vON       , 1010},
 {"OR"     , 2, OPER , OR       , vOR       , (f_t *) TRAITEMENT_vOR       , 1010},
 {"PAPER"  , 5, PROC , PAPER    , vPAPER    , (f_t *) TRAITEMENT_vPAPER    , 1010},
 {"PATTERN", 7, PROC , PATTERN  , vPATTERN  , (f_t *) TRAITEMENT_vPATTERN  , 1010},
 {"PEEK"   , 4, FUNC , PEEK     , vPEEK     , (f_t *) TRAITEMENT_vPEEK     , 1010},
 {"PI"     , 2, VALUE, PI       , vPI       , (f_t *) TRAITEMENT_vPI       , 0xDE77},
 {"PING"   , 4, NONE , PING     , vPING     , (f_t *) TRAITEMENT_vPING     , 0xFA9F},
 {"PLAY"   , 4, PROC , PLAY     , vPLAY     , (f_t *) TRAITEMENT_vPLAY     , 1010},
 {"PLOT"   , 4, PROC , PLOT     , vPLOT     , (f_t *) TRAITEMENT_vPLOT     , 1010},
 {"POINT"  , 5, PROC , POINT    , vPOINT    , (f_t *) TRAITEMENT_vPOINT    , 1010},
 {"POKE"   , 4, PROC , POKE     , vPOKE     , (f_t *) TRAITEMENT_vPOKE     , 1010},
 {"POP"    , 3, PROC , POP      , vPOP      , (f_t *) TRAITEMENT_vPOP      , 1010},
 {"POS"    , 3, FUNC , POS      , vPOS      , (f_t *) TRAITEMENT_vPOS      , 1010},
 {"PRINT"  , 5, FUNC , PRINT    , vPRINT    , (f_t *) TRAITEMENT_vPRINT    , 1010},
 {"?"      , 1, FUNC , PRINT    , vPRINT    , (f_t *) TRAITEMENT_vPRINT    , 1010},
 {"PULL"   , 4, PROC , PULL     , vPULL     , (f_t *) TRAITEMENT_vPULL     , 1010},
 {"READ"   , 4, FUNC , READ     , vREAD     , (f_t *) TRAITEMENT_vREAD     , 1010},
 {"RECALL" , 6, PROC , RECALL   , vRECALL   , (f_t *) TRAITEMENT_vRECALL   , 1010},
 {"RELEASE", 7, PROC , RELEASE  , vRELEASE  , (f_t *) TRAITEMENT_vRELEASE  , 1010},
 {"REM"    , 3, NONE , REM      , vREM      , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"REPEAT" , 6, PROC , REPEAT   , vREPEAT   , (f_t *) TRAITEMENT_vREPEAT   , 1010},
 {"RESTORE", 7, PROC , RESTORE  , vRESTORE  , (f_t *) TRAITEMENT_vRESTORE  , 1010},
 {"RETURN" , 6, PROC , RETURN   , vRETURN   , (f_t *) TRAITEMENT_vRETURN   , 1010},
 {"RIGHT$" , 5, FUNC , RIGHT    , vRIGHT    , (f_t *) TRAITEMENT_vRIGHT    , 1010},
 {"RND"    , 3, FUNC , RND      , vRND      , (f_t *) TRAITEMENT_vRND      , 1010},
 {"RUN"    , 3, PROC , RUN      , vRUN      , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"SCRN"   , 4, FUNC , SCRN     , vSCRN     , (f_t *) TRAITEMENT_vSCRN     , 1010},
 {"SGN"    , 3, FUNC , SGN      , vSGN      , (f_t *) TRAITEMENT_vSGN      , 1010},
 {"SHOOT"  , 5, NONE , SHOOT    , vSHOOT    , (f_t *) TRAITEMENT_vSHOOT    , 0xFAB5},
 {"SIN"    , 3, FUNC , SIN      , vSIN      , (f_t *) TRAITEMENT_vSIN      , 0xE392},
 {"SOUND"  , 5, PROC , SOUND    , vSOUND    , (f_t *) TRAITEMENT_vSOUND    , 1010},
 {"SPC"    , 3, FUNC , SPC      , vSPC      , (f_t *) TRAITEMENT_vSPC      , 1010},
 {"SQR"    , 3, FUNC , SQR      , vSQR      , (f_t *) TRAITEMENT_vSQR      , 0xE22E},
 {"STEP"   , 4, PROC , STEP     , vSTEP     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"STOP"   , 4, PROC , STOP     , vSTOP     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"STORE"  , 5, PROC , STORE    , vSTORE    , (f_t *) TRAITEMENT_vSTORE    , 1010},
 {"STR$"   , 4, FUNC , STR      , vSTR      , (f_t *) TRAITEMENT_vSTR      , 1010},
 {"TAB"    , 3, FUNC , TAB      , vTAB      , (f_t *) TRAITEMENT_vTAB      , 1010},
 {"TAN"    , 3, FUNC , TAN      , vTAN      , (f_t *) TRAITEMENT_vTAN      , 0xE3DB},
 {"TEXT"   , 4, PROC , TEXT     , vTEXT     , (f_t *) TRAITEMENT_vTEXT     , 0xEC21},
 {"THEN"   , 4, PROC , THEN     , vTHEN     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"TO"     , 2, PROC , TO       , vTO       , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"TROFF"  , 5, NONE , TROFF    , vTROFF    , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"TRON"   , 4, NONE , TRON     , vTRON     , (f_t *) TRAITEMENT_vNULL     , 1010},
 {"TRUE"   , 4, VALUE, TRUE     , vTRUE     , (f_t *) TRAITEMENT_vTRUE     , 1010},
 {"UNTIL"  , 5, PROC , UNTIL    , vUNTIL    , (f_t *) TRAITEMENT_vUNTIL    , 1010},
 {"USR"    , 3, PROC , USR      , vUSR      , (f_t *) TRAITEMENT_vUSR      , 1010},
 {"VAL"    , 3, FUNC , VAL      , vVAL      , (f_t *) TRAITEMENT_vVAL      , 1010},
 {"WAIT"   , 4, PROC , WAIT     , vWAIT     , (f_t *) TRAITEMENT_vWAIT     , 1010},
 {"ZAP"    , 3, NONE , ZAP      , vZAP      , (f_t *) TRAITEMENT_vZAP      , 0xFAE1},
 {"&"      , 1, NONE , AMPERSAND, vAMPERSAND, (f_t *) TRAITEMENT_vAMPERSAND, 1010},
 {"!"      , 1, NONE , SHRIEK   , vSHRIEK   , (f_t *) TRAITEMENT_vSHRIEK   , 1010},
 {"+"      , 1, NONE , PLUS     , vPLUS     , (f_t *) TRAITEMENT_vPLUS     , 1010},
 {"-"      , 1, NONE , MINUS    , vMINUS    , (f_t *) TRAITEMENT_vNULL     , 1010/*(f_t *) TRAITEMENT_vMINUS    */},
 {"*"      , 1, NONE , MULTIPLY , vMULTIPLY , (f_t *) TRAITEMENT_vNULL     , 1010/*(f_t *) TRAITEMENT_vMULTIPLY */},
 {"/"      , 1, NONE , DIVIDE   , vDIVIDE   , (f_t *) TRAITEMENT_vNULL     , 1010/*(f_t *) TRAITEMENT_vDIVIDE   */},
 {"^"      , 1, NONE , POWER    , vPOWER    , (f_t *) TRAITEMENT_vNULL     , 1010/*(f_t *) TRAITEMENT_vPOWER    */},
 {"<"      , 1, NONE , LT       , vLT       , (f_t *) TRAITEMENT_vNULL     , 1010/*(f_t *) TRAITEMENT_vLT       */},
 {"=<"     , 2, NONE , LE       , vLE       , (f_t *) TRAITEMENT_vNULL     , 1010/*(f_t *) TRAITEMENT_vLE       */},
 {"<>"     , 2, NONE , NE       , vNE       , (f_t *) TRAITEMENT_vNULL     , 1010/*(f_t *) TRAITEMENT_vNE       */},
 {"="      , 1, NONE , EQ       , vEQ       , (f_t *) TRAITEMENT_vEQ       , 1010    },
 {">"      , 1, NONE , GT       , vGT       , (f_t *) TRAITEMENT_vNULL     , 1010/*(f_t *) TRAITEMENT_vGT       */},
 {">="     , 2, NONE , GE       , vGE       , (f_t *) TRAITEMENT_vNULL     , 1010/*(f_t *) TRAITEMENT_vGE       */},
};

#define YYDEBUG 1
#define DEBUG 1
#ifdef DEBUG
     int dbgToken_o(int tok, char *s) {
         printf("ex1.l : token_o %s\n", s);
         return tok;
     }
     int dbgToken_t(int tok) {
         switch (tok)
         {
           case vVarINTEGER : printf("ex1.l : token_t vVarINTEGER (%s)\n", yytext);break;
           case vVarFLOAT   : printf("ex1.l : token_t vVarFLOAT   (%s)\n", yytext);break;
           case vVarSTRING  : printf("ex1.l : token_t vVarSTRING  (%s)\n", yytext);break;
           default          : printf("ex1.l : token_t %s \n"             , yytext);break;
          }
         return tok;
     }
     int dbgToken_s(int tok, char *s) {
         printf("ex1.l : token_s %s=]%s[\n",s, yytext);
         return tok;
     }
     int dbgTokeniValue(int tok, char *s) {
         printf("ex1.l : token_i %s (%i)\n", s, yylval.iValue);
         return tok;
     }
     int dbgTokenfValue(int tok, char *s) {
         printf("ex1.l : token_f %s (%f)\n", s, yylval.fValue);
         return tok;
     }
/* #define RETURN_o(x)      return dbgToken_o(x, #x)     */
/* #define RETURN_s(x)      return dbgToken_s(x, #x)     */
/* #define RETURN_t(x)      return dbgToken_t(x)         */
/* #define RETURN_iValue(x) return dbgTokeniValue(x, #x) */
/* #define RETURN_fValue(x) return dbgTokenfValue(x, #x) */
#define RETURN_o(x)      return(x)
#define RETURN_s(x)      return(x)
#define RETURN_t(x)      return(x)
#define RETURN_iValue(x) return(x)
#define RETURN_fValue(x) return(x)
#else
#define RETURN_o(x)      return(x)
#define RETURN_s(x)      return(x)
#define RETURN_t(x)      return(x)
#define RETURN_iValue(x) return(x)
#define RETURN_fValue(x) return(x)
#endif

/* Tampon de sauvegarde pour les commentaires associs au REM */
#define iMAXBUFREM ((int) 80)
char sBUF_REM[iMAXBUFREM+1];
char *pBUFREM;
int iBUFREM;

/* Position dans le tableau token du token trait par le lexer */
int pos;
%}
alphabetic [A-Za-z]
digit [0-9]
alphanumeric ({alphabetic}|{digit})
word ({alphabetic}({alphabetic}|{digit})*(\$|\%)?)
float ([+-]?({digit}*)\.{digit}+)
qstring \"[^\"\n]*[\"\n]
hex [A-F0-9]
%x lREM
%%
[ \t]      ;
[\n]       RETURN_o(vCR);
#{hex}+    { yylval.sValue = strdup(yytext); RETURN_o(vHEXA);            }
{float}    { yylval.fValue = atof(yytext);   RETURN_fValue(vCstFLOAT);   }
{digit}+   { yylval.iValue = atoi(yytext);   RETURN_iValue(vCstINTEGER); }
{word}     { int i = resWord(&pos);
             /* printf("ex1.l : {word}: pos=%d\n", pos ); */
             if (i == vREM) { BEGIN lREM ; pBUFREM = sBUF_REM; } 
             else { 
                    if (pos >= 1000) { yylval.iValue = (pos - 1000); } else yylval.sValue = strdup(yytext);
                    RETURN_t(i); 
             }
           }
<lREM>.    {
             if (iBUFREM < iMAXBUFREM) { *pBUFREM++ = *yytext; iBUFREM++; }
            }
<lREM>[\n] {
             *pBUFREM = 0;
             BEGIN 0;
             yyunput('\n'); /* Le CR est le terminateur d'une ligne basic ... */
             yylval.sValue = strdup(sBUF_REM);
             RETURN_s(vREM);
            }
{qstring}  {
             if (yytext[yyleng-1] != '"')      { yylval.sValue = strdup(yytext); RETURN_s(vCstSTRING_NOT_DEFINED); }
                                          else { yylval.sValue = strdup(yytext); RETURN_s(vCstSTRING);             }
            }
'          RETURN_o(vREM);
:          RETURN_o(vSEPARATOR);
!          RETURN_o(vSHRIEK);
&          RETURN_o(vAMPERSAND);
@          RETURN_o(vAT);
"="        { yylval.iValue = seekPosOp(); RETURN_o(vEQ);       }
">"        { yylval.iValue = seekPosOp(); RETURN_o(vGT);       }
">="       { yylval.iValue = seekPosOp(); RETURN_o(vGE);       }
"<"        { yylval.iValue = seekPosOp(); RETURN_o(vLT);       }
"<="       { yylval.iValue = seekPosOp(); RETURN_o(vLE);       }
"<>"       { yylval.iValue = seekPosOp(); RETURN_o(vNE);       }
"*"        { yylval.iValue = seekPosOp(); RETURN_o(vMULTIPLY); }
"/"        { yylval.iValue = seekPosOp(); RETURN_o(vDIVIDE);   }
"-"        { yylval.iValue = seekPosOp(); RETURN_o(vMINUS);    }
"+"        { yylval.iValue = seekPosOp(); RETURN_o(vPLUS);     }
"^"        { yylval.iValue = seekPosOp(); RETURN_o(vPOWER);    }
[(),;]	   return yytext[0];
%%
int resWord(int * pos_in_token)
{
 int i = 0;
 int pos = vNOT_FOUND;
 char * pTmp = NULL;

 /* INIT */
 *pos_in_token = 0; 
 
 /*=== Recherche l'existence d'un mot cl dans la chaine */
 /*=== Balayage complet pour dterminer l'existence de(s)*/
 /*=== mot(s) cl(s) dans le mot                         */
 /*===                                                   */
 /*=== Ex : SINTO : mots cls : SIN, TO ET INT !!!       */
 i   = 0;
 pos = vNOT_FOUND;
 do {
      pTmp = strstr(yytext, token[i].name);
      if  (pTmp != NULL)
      {
        if (   (pTmp == yytext)
            && ( (pos == vNOT_FOUND) || (pos == vKEYWORD_IN_WORD) )  ) {
           pos = i;
         }
        else if (pos == vNOT_FOUND) pos = vKEYWORD_IN_WORD;
       }
      i++;
  }
 while ((i < MAX_TOKEN) );


 /*=== Est-ce un identifiant qui ne contient pas de mot-cl ?  */
 if (pos == vNOT_FOUND) { /* OUI, IDENTIFIANT */
    if (yytext[yyleng-1] == '%') return vVarINTEGER;
    if (yytext[yyleng-1] == '$') return vVarSTRING;
    return vVarFLOAT;
 }

 /*=== Le mot trait contient-il un mot cl en dbut de chaine ? */
 if (pos >= 0) {
    /* Si le mot trait est plus grand que le mot cl on garde que le mot cl*/
    /* Dans ce cas, les lettres en trop seront "reparss"                    */
    
    if (token[pos].len < yyleng) { 
       /* Cas de EXP/EXPLODE */
       if ((token[pos].code == EXP) && (! strncmp(&yytext[0], "EXPLODE", 7))) pos++;
           
       yyless(token[pos].len); 
    }
    
    printf("ex1.l : resWord(), yytext=<%s>, pos=%d\n", yytext, pos);
    *pos_in_token = 1000 + pos;
    
    return token[pos].code_parse;
  }

 /*=== Le mot trait contient un mot cl au milieu et/ou en fin de chaine */
 if (pos == vKEYWORD_IN_WORD) return vKEYWORD_IN_WORD;

 /*=== Cela ne devrait pas arriver !! */
 return vERROR_UNKNOWN;
}

int seekPosOp()
{
  int i = 0;
  char * pTmp = NULL;
  
  for (i = NB_TOKEN_BASIC ; i < (MAX_TOKEN+1); i++)
  {
    /* printf("ex1.l: seekPosOp: name='%s'\n", token[i].name); */
    if (strcmp( yytext, token[i].name) == 0) { return i; }
   }
  return -1;
} 

%%